/*M*
//  PVCS:
//      $Workfile:   ipmignustub.c  $
//      $Revision:   1.0  $
//      $Modtime:   21 Oct 2004 15:31:14  $
//      $Author:   arcress@users.sourceforge.net  $  
//
//  This implements stub routines for the GNU FreeIPMI interface.
// 
//  10/21/03 ARC - created.
//  11/11/04 ARC - removed extra include files.
 *M*/
/*----------------------------------------------------------------------*
The BSD License 

Copyright (c) 2002, Intel Corporation
Copyright (c) 2009 Kontron America, Inc.
All rights reserved.

Redistribution and use in source and binary forms, with or without 
modification, are permitted provided that the following conditions are met:

  a.. Redistributions of source code must retain the above copyright notice, 
      this list of conditions and the following disclaimer. 
  b.. Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation 
      and/or other materials provided with the distribution. 
  c.. Neither the name of Intel Corporation nor the names of its contributors 
      may be used to endorse or promote products derived from this software 
      without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR 
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *----------------------------------------------------------------------*/

#include <stdio.h>
#include <fcntl.h>
#include <string.h>

#define uchar    unsigned char

int gnu_retry_wait_time = 1;
int gnu_retry_attempts  = 5;

int ipmi_open_gnu(char *node, char *user, char *pswd, int fdebuglan)
{
   return -1;
}
 
 
int ipmi_close_gnu(char *node)
{
   return -1;
}
 
#define MAX_LEN_RQ   25
#define MAX_LEN_RS   64

int ipmicmd_gnu(char *node, uchar cmd, uchar netfn, uchar lun, uchar sa,
		uchar *pdata, uchar sdata, uchar *presp, int *sresp, 
		uchar *pcc, char fdebugcmd)
{
   int rv = -1;

   /* check sdata/sresp against MAX_ */
   if (sdata > MAX_LEN_RQ)  return(-5);
   if (*sresp > MAX_LEN_RS)  return(-5);

   /* stub */ 
   return(rv);
}

int ipmi_cmd_gnu(char *node, ushort cmd, uchar *pdata, uchar sdata, 
	 	uchar *presp, int *sresp, uchar *pcc, char fdebugcmd)
{
   return (-1);
}

/* end ipmignu.c */
